-- Update the display at 500 msec intervals (see event at end)
function mytimer(time)

    fr = ipc.readUW(0x0274)
    if fr ~= 0 then fr = 32768/fr end
    fr = math.floor((fr * 10) + 0.5)/10
    mem = ipc.readUD(0x024C)
    memmb = math.floor((mem/1024) + 0.5)
    maxmem = ipc.readUD(0x0290)
    maxmemmb = math.floor((maxmem/1024) + 0.5)
    traff = ipc.readUD(0x025C)
    
    ipc.display("Frame Rate   " .. fr .. 
    						" fps\nVAS free       " .. memmb .. 
    						" Mb\nMax block free " .. maxmemmb .. 
    						" Mb\nTraffic            " .. traff)
end

-- Adjust timing to taste: 500 = 1/2 second
event.timer(500, "mytimer")
