-- "LogLvars" example LUA plug-in, by Pete Dowson, February 2009

displaymax = 15

local vals = {}
local names = {}
local lines = {}

for i = 0, displaymax, 1 do
   lines[i] = ""
end

line = 0
scan = true
postscan = false

while 1 do
   i = 0
   while i < 65536 do
      if scan then
         name = ipc.getLvarName(i)
         if name == nil then
            scan = false
            postscan = true
            break
         end
      
         if name ~= names[i] then
            vals[i] = nil
            names[i] = name
         end
      
      elseif names[i] == nil then
         break
      end
      
      n = ipc.readLvar(names[i])
      
      if n == nil then
         scan = true
         break
      end
         
      dodisp = false
      
      if n ~= vals[i] then
      	 lines[line] = "L:" .. names[i] .. "=" .. n
         ipc.log(lines[line])
         vals[i] = n
     
         line = line + 1
         if line > displaymax then
            line = 0
         end
         
         dodisp = true
      end
      
      if postscan or (dodisp and not scan) then
	 j = line
         disp = ""
         
         repeat
            disp = disp .. "\n" .. lines[j]
            
            j = j + 1
            if j > displaymax then 
               j = 0
            end       
         until j == line 
         
         ipc.display(disp)
            
         postscan = false
      end
      
      i = i + 1
   end

   ipc.sleep(5)

end
