path="\\\\myfscomputer\\fsplans\\wxradar.bmp"
positionx = 100
positiony = 100
size = 600

title = "WX Radar"
shown = false
w = wnd.open(title, positionx,positiony,size,size/2)
wnd.backcol(w, 0x000)
wnd.hide(w)

function params()
	wopts = ipc.readUW(0x8624)
	if logic.And(wopts, 1) ~= 0 then w1 = "Col"
	else w1 = "Nml" end
	if logic.And(wopts, 2) ~= 0 then  w2 = "Stb"
	else w2 = "Pch" end
	if logic.And(wopts, 4) ~= 0 then  w3 = "Msc"
	else w3 = "Uni" end
	
	title = string.format("WX Radar: Range % 2dnm, Tilt % 2.1f, Opts: %s %s %s",
		ipc.readSW(0x861C), ipc.readSW(0x861E)/10, w1, w2, w3)
	
	wnd.title(w, title)
	
	if logic.And(wopts, 128) ~= 0 then
		if not shown then
	     wnd.show(w)
		   shown = true
		end
	elseif shown then
	  wnd.hide(w)
		shown = false
	end
end

function display()
ipc.log("display")
  wnd.bitmap(w, path)
end

event.offset(0x8602, "UW", "display")
event.offset(0x8601, "UB", "params")
event.offset(0x8608, "FLT", "params")
event.offset(0x860C, "FLT", "params")
event.offset(0x8610, "FLT", "params")
event.offset(0x8614, "FLT", "params")
event.offset(0x8618, "FLT", "params")
event.offset(0x861C, "UW", "params")
event.offset(0x861E, "SW", "params")
event.offset(0x8620, "UW", "params")
event.offset(0x8622, "SW", "params")
event.offset(0x8624, "UW", "params")

	