-- This supports the "testclnt" Plug-In to test the facilities

-- The SOCKET module is built into FSUIPC, but is not active until "required"
socket = require("socket");

-- Change the host name to the name of the PC running this Server
-- The "localhost" name only serves local clients
host = "localhost";

-- The port must match the port selected in the client and not clash with others.
port = "8384";

server = assert(socket.bind(host, port));
ack = "\n";
while 1 do
    print("server: waiting for client connection...");
    control = server:accept();
    if control ~= nil then
    		print("server: client connected!");
    		while 1 do 
        		command = control:receive();
        		if command == nil then
            		print("server: client disconnected");
             		break
        		end
        		assert(control:send(ack));
        		print(command);
        		(loadstring(command))();
    		end
    end
end
