colours = { 0x000, 0xfff, 0xf00, 0x0f0, 0x00f, 0xff0, 0xf0f, 0x0ff }
doshow = 1
shown = 2
textset = false
menuset = false
time2 = 0
time3 = 0
timeclear2 = 0
timeclear3 = 0

w1 = wnd.open("Radar Contact", WND_FIXED, 1280,0,1024,768)
wnd.backcol(w1, 0x000)
wnd.textcol(w1, 0x0f0)
wnd.font(w1, WND_ARIAL, -10, WND_BOLD)

w2 = wnd.open("FSX Text", WND_FIXED, 1280,0,1024,150)
wnd.backcol(w2, 0xfff)
wnd.textcol(w2, 0x000)
wnd.font(w2, WND_ARIAL, 24, WND_BOLD)

w3 = wnd.open("FSX Menu", WND_FIXED, 1280,150,1024,618)
wnd.backcol(w3, 0x88f)
wnd.textcol(w3, 0x000)
wnd.font(w3, WND_ARIAL, 25, WND_BOLD)

ext.state("FSX Menu", EXT_HIDE)
ext.state("FSX Text", EXT_HIDE)
ext.state("Radar Contact", EXT_NRML)

local function testifclear()
  doshow = 1
	if menuset or textset then
	   doshow = 2
	end
	if doshow ~= shown then
	   if doshow == 1 then
				ext.state("FSX Text", EXT_HIDE)
				ext.state("FSX Menu", EXT_HIDE)
				ext.state("Radar Contact", EXT_NRML)
		 else
				ext.state("Radar Contact", EXT_HIDE)
		 		ext.state("FSX Text", EXT_NRML)
				ext.state("FSX Menu", EXT_NRML)
		 end
     shown = doshow
	end
end

local function clearw2()
   wnd.clear(w2)
	 textset = false
   testifclear()
end   

function clearw3()
   wnd.clear(w3)
	 menuset = false
   testifclear()
end   

function textandmenu(mtype, colour, scroll, delay, id, n, msgs)
	doshow = 1
	if mtype == 2 then
	   -- Menu
	  time3 = 0
	  if n == 0 then 
	     wnd.clear(w3)
	     menuset = false
			 testifclear()
	  else
	     menuset = true
			 testifclear()
	     wnd.clear(w3)
		   wnd.text(w3, " " .. msgs[1])
		   wnd.text(w3, " ")
		   wnd.text(w3, " " .. msgs[2])
		   wnd.text(w3, " ")
		   i = 3
		   j = 1
		   while i <= n do
		   	  wnd.text(w3, " " .. j .. " - " .. msgs[i])
		      i = i + 1
		      j = j + 1
		      if (j > 9) then 
		         j = 0
		      end
		   end
		   if delay ~= 0 then
	  	 		timeclear3 = delay * 1000
		   		time3 = ipc.elapsedtime()
		   end
	  end
	else
	  -- Text
	  time2 = 0
		if n == 0 then 
	     wnd.clear(w2)
	     textset = false
			 testifclear()
	  else
	     textset = true
			 testifclear()
	  	 wnd.textcol(w2, colours[colour+1])
 			 wnd.backcol(w2, logic.Xor(colours[colour+1], 0xfff))
	  	 wnd.text(w2, msgs[1])
	  	 if delay then
	  	 		timeclear2 = delay * 1000
		   		time2 = ipc.elapsedtime()
		   end
	  end
	end
end

function time()
  val = ipc.elapsedtime()
	if time2 ~= 0 and ((val - time2) > timeclear2) then
	   clearw2()
	   time2 = 0
	end
	if time3 ~= 0 and ((val - time3) > timeclear3) then
	   clearw3()
	   time3 = 0
	end
end	

function update1(off, val)
	 wnd.clear(w1)
	 wnd.text(w1, val)
end

event.textmenu(0, "textandmenu")
event.offset(0x3380, "STR", "update1")
event.timer(500, "time")
testifclear()
